import type { ExecutionExtra, UnwrapPlanTuple } from "../interfaces.js";
import type { ExecutableStep } from "../step.js";
import { UnbatchedExecutableStep } from "../step.js";
export declare class ListStep<const TPlanTuple extends readonly ExecutableStep<any>[]> extends UnbatchedExecutableStep<UnwrapPlanTuple<TPlanTuple>> {
    static $$export: {
        moduleName: string;
        exportName: string;
    };
    isSyncAndSafe: boolean;
    allowMultipleOptimizations: boolean;
    constructor(list: TPlanTuple);
    toStringMeta(): string;
    tupleToTuple(results: Array<UnwrapPlanTuple<TPlanTuple>>, tuple: UnwrapPlanTuple<TPlanTuple>): UnwrapPlanTuple<TPlanTuple>;
    execute(values: any[][]): Array<UnwrapPlanTuple<TPlanTuple>>;
    unbatchedExecute(extra: ExecutionExtra, ...values: any[]): UnwrapPlanTuple<TPlanTuple>;
    deduplicate(peers: ListStep<TPlanTuple>[]): ListStep<TPlanTuple>[];
    at<TIndex extends keyof TPlanTuple>(index: TIndex): TPlanTuple[TIndex];
}
export declare function list<const TPlanTuple extends readonly ExecutableStep<any>[]>(list: TPlanTuple): ListStep<TPlanTuple>;
//# sourceMappingURL=list.d.ts.map